include msort.e
include sort.e
--Test code for comparison of merge sort to RDS shell sort (sort.e).

integer n, tf
n=100

tf=open("msorttst.txt","w")
puts(tf,"Test of merge sort by Dr. Donald R. Cahela\n")
printf(tf,"Comparison of merge sort with RDS shell sort for %d random items\n",n)
puts(tf,"No. of randoms, time for merge, time for shell, ratio of merge/shell\n")
sequence x,y

--Compare merge sorting routine to the shell sort included in RDS Euphoria.
atom t0, exctmerge, exctshell
integer nmerge, nshell
--Sorting a list of 10^6 random items once will give an accurate execution time.
--Pentium running at  3GHz.
for j=1 to 6  do
    x=repeat(0,n)
    y=repeat(0,n)
    for i=1 to n do
	x[i]=rand(1000000000)
    end for
    nmerge=floor(2000001/n)
    nshell=floor(nmerge/2)
    if nmerge=0 then
	nmerge=1
    end if
    if nshell=0 then
	nshell=1
    end if

    printf(1,"Preforming merge sort of %d random items %d times\n",{n,nmerge})
    t0=time()
    for i=1 to nmerge do
	y=merge_sort(x)
    end for
    exctmerge=time()-t0
    exctmerge/=nmerge
    
    puts(1,"x=")
    ?x
    puts(1,"y=")
    ?y
    printf(1,"Preforming shell sort of same %d random items %d times for comparison\n",{n,nshell})
    t0=time()
    for i=1 to nshell do
	y=sort(x)
    end for
    exctshell=time()-t0
    exctshell/=nshell
    printf(1,"time to execute merge and shell sort routines=%g, %g sec\n",{exctmerge,exctshell})
    printf(1,"Shell sort is %g times faster than merge sort\n",exctmerge/exctshell)
    printf(tf,"%d, %g, %g, %g\n",{n,exctmerge,exctshell,exctmerge/exctshell})
    n*=10
end for
puts(1,"merge sort test finished\n")
close(tf)
