--Merge sort algorithm
--Separate a list into groups of two values, then merge the sorted lists. 

--with trace
--trace(1)

--merge two sequences of atoms that are already sorted.
global function atom_merge(sequence x, sequence y)
sequence z
integer xl, yl, xi, yi, n, zi
    xl=length(x)
    yl=length(y)
    n=xl+yl
    z=repeat(0,n)
    xi=1
    yi=1
    zi=1
--Special case: both lists to be merged are empty
    if xl=0 and yl=0 then
	z={}
    else
--Merge lists by choosing the smaller of the leading values.
	while xi<=xl and yi<=yl do
	    if x[xi]<y[yi] then
		z[zi]=x[xi]
		xi+=1
	    else
		z[zi]=y[yi]
		yi+=1
	    end if
	    zi+=1
	end while
--list x is exhausted, so append the rest of the y values to z
	if xi>xl then
	    for i=zi to n do
		z[i]=y[yi+i-zi]
	    end for
	end if
--list y is exhausted, so append the rest of the x values to z
	if yi>yl then
	    for i=zi to n do
		z[i]=x[xi+i-zi]
	    end for
	end if
    end if
return z
end function

--test the merge function
--sequence x, y, z
--x={1,2,5,10,12}
--y={3,4,7,11,15,17,20,25}
--z=atom_merge(x,y)
--puts(1,"x=")
--?x
--puts(1,"y=")
--?y
--puts(1,"merge x and y, z=")
--?z

--with trace
--trace(1)

--Sort a linear array of real values in ascending order using merge method.
global function merge_sort(sequence x)
integer lx, level, nmerges, lseq
sequence y, extra, odd, nseg, npseg
atom temp
--Create a three dimensional array of linear sequences to hold the sequences 
--to be merged.  The first level has the input sequence split into two element 
--lists.  The first level of two value lists will hold a power of two values.
--2, 4, 8, 16, 32, 64,... For example if there are 33 values to sort, then 
--enough space will be allocated to hold 64 values.  The extra lists will be 
--set equal to an empty list.
--Adjacent lists are merged until the lists are merged into a single list.
    lx=length(x)
--Compute the number of levels of merge operations to be done.
    nmerges=1
    lseq=2
    while lx>lseq do
	nmerges+=1
	lseq*=2
    end while

    extra=repeat(0,nmerges)
    odd=repeat(0,nmerges)
    npseg=repeat(0,nmerges)
    nseg=repeat(0,nmerges)
    
    npseg[1]=2
    extra[1]=remainder(lx,npseg[1])
    odd[1]=(extra[1]!=0)
--true=1, false=0 in Euphoria prog lang (C convention)
    nseg[1]=power(2,nmerges)
    y=repeat(repeat(repeat(0,npseg[1]),nseg[1]),1)
    
    for i=2 to nmerges do
	npseg[i]=2*npseg[i-1]
	extra[i]=remainder(lx,npseg[i])
	odd[i]=(extra[i]!=0)
--true=1, false=0 in Euphoria prog lang (C convention)
	nseg[i]=nseg[i-1]/2
    end for

    for i=2 to nmerges do
	y=append(y,repeat(repeat(0,npseg[i]),nseg[i]))
    end for
    level=nmerges+1
    y=append(y,repeat(0,lx))


--Assign x to the first level of lists which are two elements each and 
--sort each of the two element lists.
    for i=1 to nseg[1] do
	if (i-1)*2+1<=lx and i*2<=lx then
	    y[1][i][1]=x[(i-1)*2+1]
	    y[1][i][2]=x[i*2]
	    if y[1][i][1]>y[1][i][2] then
		temp=y[1][i][1]
		y[1][i][1]=y[1][i][2]
		y[1][i][2]=temp
	    end if
	elsif (i-1)*2+1<=lx and i*2>lx then
	    y[1][i]={x[(i-1)*2+1]}
	else
	    y[1][i]={}
	end if
    end for

--Merge the lists until one list is formed  
    for j=1 to level-2 do
	for i=1 to nseg[j+1] do
	    y[j+1][i]=atom_merge(y[j][2*(i-1)+1],y[j][2*i])
	end for
    end for
    y[level]=atom_merge(y[level-1][1],y[level-1][2])
	
    return y[level]
end function

puts(1,"msort.e Dr. Donald R. Cahela, copyright 2008\n")
